/**
 * @file main.c
 * @author WHXY
 * @brief
 * @version 0.1
 * @date 2022-01-18
 *
 * @copyright Copyright (c) 2021
 *

* 代码许可和免责信息
* 武汉芯源半导体有限公司授予您使用所有编程代码示例的非专属的版权许可，您可以由此
* 生成根据您的特定需要而定制的相似功能。根据不能被排除的任何法定保证，武汉芯源半
* 导体有限公司及其程序开发商和供应商对程序或技术支持（如果有）不提供任何明示或暗
* 含的保证或条件，包括但不限于暗含的有关适销性、适用于某种特定用途和非侵权的保证
* 或条件。
* 无论何种情形，武汉芯源半导体有限公司及其程序开发商或供应商均不对下列各项负责，
* 即使被告知其发生的可能性时，也是如此：数据的丢失或损坏；直接的、特别的、附带的
* 或间接的损害，或任何后果性经济损害；或利润、业务、收入、商誉或预期可节省金额的
* 损失。
* 某些司法辖区不允许对直接的、附带的或后果性的损害有任何的排除或限制，因此某些或
* 全部上述排除或限制可能并不适用于您。
*******************************************************************************/
/******************************************************************************
 * Include files
 ******************************************************************************/
#include "main.h"
#include "cw32l052_autotrim.h"
#include "cw32l052_rcc.h"
#include "cw32l052_gpio.h"
#include "cw32l052_systick.h"

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/******************************************************************************
 * Global variable definitions (declared in header file with 'extern')
 ******************************************************************************/

/******************************************************************************
 * Local type definitions ('typedef')
 ******************************************************************************/

/******************************************************************************
 * Local function prototypes ('static')
 ******************************************************************************/
void GPIO_Configuration(void);
void NVIC_Configuration(void);

/******************************************************************************
 * Local variable definitions ('static')                                      *
 ******************************************************************************/
AUTOTRIM_TimeCntInitTypeDef AUTOTRIM_TimeCntInitStruct = {0};

uint8_t intflag;
/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/*****************************************************************************
 * Function implementation - global ('extern') and local ('static')
 ******************************************************************************/


/**
 ******************************************************************************
 ** \brief  Main function of project
 **
 ** \return uint32_t return value, if needed
 **
 ** This sample toggle GPIOA.00
 **
 ******************************************************************************/
int32_t main(void)
{
    RCC_APBPeriphClk_Enable2(RCC_APB2_PERIPH_AUTOTRIM, ENABLE);  //Open AUTOTRIM and GPIOA Clk
    RCC_AHBPeriphClk_Enable(RCC_AHB_PERIPH_GPIOA | RCC_AHB_PERIPH_GPIOB | RCC_AHB_PERIPH_GPIOF| RCC_AHB_PERIPH_GPIOC, ENABLE);    //Open GPIOA &GPIOB  Clk

    /* NVIC Configuration */
    NVIC_Configuration();

    /* GPIO Configuration */
    GPIO_Configuration();

    RCC_SystemCoreClockUpdate( RCC_Sysctrl_GetHClkFreq() );

    PA15_SETHIGH();
    PC10_SETHIGH();
    FirmwareDelay(2000000);

   PA15_SETLOW();
    PC10_SETLOW();
    FirmwareDelay(2000000);


    RCC_LSE_Enable(RCC_LSE_MODE_OSC,RCC_LSE_AMP_NORMAL,RCC_LSE_DRIVER_LARGER);

    AUTOTRIM_TimeCntStructInit( &AUTOTRIM_TimeCntInitStruct );
    AUTOTRIM_TimeCntInitStruct.AUTOTRIM_ClkSource = AUTOTRIM_CLKSOURCE_LSE;
    AUTOTRIM_TimeCntInitStruct.AUTOTRIM_Prescaler = AUTOTRIM_PRS_DIV32768;
    AUTOTRIM_TimeCntInitStruct.AUTOTRIM_Period = 4;
    AUTOTRIM_TimeCntInit(&AUTOTRIM_TimeCntInitStruct);

    intflag = 0;
    //使能AUTOTRIM下溢出中断
    AUTOTRIM_ITConfig(AUTOTRIM_IT_UD, ENABLE);
    AUTOTRIM_Cmd(ENABLE);

    //DeepSleep唤醒时，保持原系统时钟来源
    RCC_WAKEUPCLK_Config(RCC_SYSCTRL_WAKEUPCLKDIS);

    while(1)
    {
        SCB->SCR = 0X04;
        __WFI();

        if(intflag ==1)
        {
            intflag = 0;
            for(uint8_t i = 0; i<6; i++)
            {
                PA15_TOG();
                PC10_TOG();
                FirmwareDelay(100000);
            }
        }
        FirmwareDelay(500000);

    }
}

/**
  * @brief  Configure the GPIO Pins.
  * @param  None
  * @retval None
  */
void GPIO_Configuration(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};

    
    GPIO_InitStruct.Pins = GPIO_PIN_15;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;

    GPIO_Init(CW_GPIOA, &GPIO_InitStruct);
		
		
    GPIO_InitStruct.Pins = GPIO_PIN_10;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;

    GPIO_Init(CW_GPIOC, &GPIO_InitStruct);

    PA15_SETLOW();
    PC10_SETLOW();
}


/**
  * @brief  Configure the nested vectored interrupt controller.
  * @param  None
  * @retval None
  */
void NVIC_Configuration(void)
{
    __disable_irq();
    NVIC_EnableIRQ(AUTOTRIM_LCD_IRQn);
    __enable_irq();
}



#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
    /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
